"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from mollie_api_python_alpha import utils
from mollie_api_python_alpha.types import BaseModel, OptionalNullable, UNSET
from mollie_api_python_alpha.utils import FieldMetadata, PathParamMetadata
import pydantic
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DisableMethodIssuerRequestTypedDict(TypedDict):
    profile_id: str
    r"""Provide the ID of the related profile."""
    method_id: str
    r"""Provide the ID of the related payment method."""
    id: str
    r"""Provide the ID of the item you want to perform this operation on."""


class DisableMethodIssuerRequest(BaseModel):
    profile_id: Annotated[
        str,
        pydantic.Field(alias="profileId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Provide the ID of the related profile."""

    method_id: Annotated[
        str,
        pydantic.Field(alias="methodId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""Provide the ID of the related payment method."""

    id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Provide the ID of the item you want to perform this operation on."""


class DisableMethodIssuerDocumentationTypedDict(TypedDict):
    r"""The URL to the generic Mollie API error handling guide."""

    href: NotRequired[str]
    type: NotRequired[str]


class DisableMethodIssuerDocumentation(BaseModel):
    r"""The URL to the generic Mollie API error handling guide."""

    href: Optional[str] = "https://docs.mollie.com/errors"

    type: Optional[str] = "text/html"


class DisableMethodIssuerLinksTypedDict(TypedDict):
    documentation: NotRequired[DisableMethodIssuerDocumentationTypedDict]
    r"""The URL to the generic Mollie API error handling guide."""


class DisableMethodIssuerLinks(BaseModel):
    documentation: Optional[DisableMethodIssuerDocumentation] = None
    r"""The URL to the generic Mollie API error handling guide."""


class DisableMethodIssuerResponseBodyData(BaseModel):
    status: Optional[int] = None
    r"""The status code of the error message. This is always the same code as the status code of the HTTP message itself."""

    title: Optional[str] = None
    r"""The HTTP reason phrase of the error. For example, for a `404` error, the `title` will be `Not Found`."""

    detail: Optional[str] = None
    r"""A detailed human-readable description of the error that occurred."""

    field: OptionalNullable[str] = UNSET
    r"""If the error was caused by a value provided by you in a specific field, the `field` property will contain the name of the field that caused the issue."""

    links: Annotated[
        Optional[DisableMethodIssuerLinks], pydantic.Field(alias="_links")
    ] = None


class DisableMethodIssuerResponseBody(Exception):
    r"""An error response object."""

    data: DisableMethodIssuerResponseBodyData

    def __init__(self, data: DisableMethodIssuerResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, DisableMethodIssuerResponseBodyData)
